diff --git a/math/Makefile b/math/Makefile
index f1b7937..d4b6d98 100644
--- a/math/Makefile
+++ b/math/Makefile
@@ -49,7 +49,7 @@ gen-libm-calls = cargF conjF cimagF crealF cabsF s_cacosF		  \
 	         s_cacoshF s_ccosF s_ccoshF s_casinF s_csinF s_casinhF	  \
 		 k_casinhF s_csinhF k_casinhF s_csinhF s_catanhF s_catanF \
 		 s_ctanF s_ctanhF s_cexpF s_clogF s_cprojF s_csqrtF	  \
-		 s_cpowF s_clog10F
+		 s_cpowF s_clog10F s_fdimF
 
 libm-calls =								  \
 	e_acosF e_acoshF e_asinF e_atan2F e_atanhF e_coshF e_expF e_fmodF \
@@ -65,7 +65,7 @@ libm-calls =								  \
 	w_tgammaF w_hypotF w_j0F w_j1F w_jnF w_lgammaF w_lgammaF_r	  \
 	w_logF w_log10F w_powF w_remainderF w_scalbF w_sinhF w_sqrtF	  \
 	w_ilogbF							  \
-	s_fpclassifyF s_fmaxF s_fminF s_fdimF s_nanF s_truncF		  \
+	s_fpclassifyF s_fmaxF s_fminF s_nanF s_truncF		  	  \
 	s_remquoF e_log2F e_exp2F s_roundF s_nearbyintF s_sincosF	  \
 	s_fmaF s_lrintF s_llrintF s_lroundF s_llroundF e_exp10F w_log2F	  \
 	s_issignalingF $(calls:s_%=m_%) x2y2m1F				  \
diff --git a/math/s_fdim.c b/math/s_fdim.c
deleted file mode 100644
index 1786521..0000000
--- a/math/s_fdim.c
+++ /dev/null
@@ -1,42 +0,0 @@
-/* Return positive difference between arguments.
-   Copyright (C) 1997-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-double
-__fdim (double x, double y)
-{
-  if (islessequal (x, y))
-    return 0.0;
-
-  double r = math_narrow_eval (x - y);
-  if (isinf (r) && !isinf (x) && !isinf (y))
-    __set_errno (ERANGE);
-
-  return r;
-}
-#ifndef __fdim
-weak_alias (__fdim, fdim)
-# ifdef NO_LONG_DOUBLE
-strong_alias (__fdim, __fdiml)
-weak_alias (__fdim, fdiml)
-# endif
-#endif
diff --git a/math/s_fdim_template.c b/math/s_fdim_template.c
new file mode 100644
index 0000000..d3e7379
--- /dev/null
+++ b/math/s_fdim_template.c
@@ -0,0 +1,40 @@
+/* Return positive difference between arguments.
+   Copyright (C) 1997-2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <math.h>
+#include <math_private.h>
+
+FLOAT
+M_DECL_FUNC (__fdim) (FLOAT x, FLOAT y)
+{
+  if (islessequal (x, y))
+    return 0;
+
+  FLOAT r = math_narrow_eval (x - y);
+  if (isinf (r) && !isinf (x) && !isinf (y))
+    __set_errno (ERANGE);
+
+  return r;
+}
+declare_mgen_alias (__fdim, fdim);
+
+#if M_LIBM_NEED_COMPAT (fdim)
+declare_mgen_libm_compat (__fdim, fdim)
+#endif
diff --git a/math/s_fdimf.c b/math/s_fdimf.c
deleted file mode 100644
index e457f9d..0000000
--- a/math/s_fdimf.c
+++ /dev/null
@@ -1,38 +0,0 @@
-/* Return positive difference between arguments.
-   Copyright (C) 1997-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-float
-__fdimf (float x, float y)
-{
-  if (islessequal (x, y))
-    return 0.0f;
-
-  float r = math_narrow_eval (x - y);
-  if (isinf (r) && !isinf (x) && !isinf (y))
-    __set_errno (ERANGE);
-
-  return r;
-}
-#ifndef __fdimf
-weak_alias (__fdimf, fdimf)
-#endif
diff --git a/math/s_fdiml.c b/math/s_fdiml.c
deleted file mode 100644
index 4a1f672..0000000
--- a/math/s_fdiml.c
+++ /dev/null
@@ -1,35 +0,0 @@
-/* Return positive difference between arguments.
-   Copyright (C) 1997-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-
-long double
-__fdiml (long double x, long double y)
-{
-  if (islessequal (x, y))
-    return 0.0f;
-
-  long double r = x - y;
-  if (isinf (r) && !isinf (x) && !isinf (y))
-    __set_errno (ERANGE);
-
-  return r;
-}
-weak_alias (__fdiml, fdiml)
diff --git a/sysdeps/generic/math-type-macros-double.h b/sysdeps/generic/math-type-macros-double.h
index 4149b39..154f416 100644
--- a/sysdeps/generic/math-type-macros-double.h
+++ b/sysdeps/generic/math-type-macros-double.h
@@ -29,12 +29,12 @@
 /* Machines without a distinct long double type
    alias long double functions to their double
    equivalent.  */
-#if defined NO_LONG_DOUBLE
+#if defined NO_LONG_DOUBLE && !defined declare_mgen_alias
 # define declare_mgen_alias(from, to)	    \
    weak_alias (from, to)		    \
    strong_alias (from, from ## l)	    \
    weak_alias (from, to ## l)
-#else
+#elif !defined declare_mgen_alias
 # define declare_mgen_alias(from, to)	    \
    weak_alias (M_SUF (from), M_SUF (to))
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/math-type-macros-double.h b/sysdeps/ieee754/ldbl-opt/math-type-macros-double.h
index 8cb5694..e9b1508 100644
--- a/sysdeps/ieee754/ldbl-opt/math-type-macros-double.h
+++ b/sysdeps/ieee754/ldbl-opt/math-type-macros-double.h
@@ -44,15 +44,20 @@
 #define LDOUBLE_cpowl_libm_version GLIBC_2_1
 #define LDOUBLE_clog10l_libm_version GLIBC_2_1
 #define LDOUBLE___clog10l_libm_version GLIBC_2_1
+#define LDOUBLE_fdiml_libm_version GLIBC_2_1
 
 /* Define compat symbols for long double on platforms
    where it was not always a distinct type.  */
-#define M_LIBM_NEED_COMPAT(f) \
-  LONG_DOUBLE_COMPAT (libm, LDOUBLE_ ## f ## l_libm_version)
+#if !defined M_LIBM_NEED_COMPAT
+# define M_LIBM_NEED_COMPAT(f) \
+   LONG_DOUBLE_COMPAT (libm, LDOUBLE_ ## f ## l_libm_version)
+#endif
 
-#define declare_mgen_libm_compat(from, to)	      \
-  compat_symbol (libm, from, to ## l,		      \
+#if !defined declare_mgen_libm_compat
+# define declare_mgen_libm_compat(from, to)	      \
+   compat_symbol (libm, from, to ## l,		      \
 		 LDOUBLE_ ## to ## l_libm_version);
+#endif
 
 #include_next <math-type-macros-double.h>
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/math-type-macros-ldouble.h b/sysdeps/ieee754/ldbl-opt/math-type-macros-ldouble.h
index d2af4bb..30cb2fb 100644
--- a/sysdeps/ieee754/ldbl-opt/math-type-macros-ldouble.h
+++ b/sysdeps/ieee754/ldbl-opt/math-type-macros-ldouble.h
@@ -22,8 +22,10 @@
 
 /* Use properly versioned symbols for long double on platforms where
    it was not always a distinct type.  */
-#define declare_mgen_alias(from, to) \
-  long_double_symbol (libm, from ## l, to ## l);
+#if !defined declare_mgen_alias
+# define declare_mgen_alias(from, to) \
+   long_double_symbol (libm, from ## l, to ## l);
+#endif
 
 #include_next <math-type-macros-ldouble.h>
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/s_fdim.c b/sysdeps/ieee754/ldbl-opt/s_fdim.c
deleted file mode 100644
index 02c95bf..0000000
--- a/sysdeps/ieee754/ldbl-opt/s_fdim.c
+++ /dev/null
@@ -1,5 +0,0 @@
-#include <math_ldbl_opt.h>
-#include <math/s_fdim.c>
-#if LONG_DOUBLE_COMPAT(libm, GLIBC_2_1)
-compat_symbol (libm, __fdim, fdiml, GLIBC_2_1);
-#endif
diff --git a/sysdeps/ieee754/ldbl-opt/s_fdiml.c b/sysdeps/ieee754/ldbl-opt/s_fdiml.c
deleted file mode 100644
index 06b760b..0000000
--- a/sysdeps/ieee754/ldbl-opt/s_fdiml.c
+++ /dev/null
@@ -1,5 +0,0 @@
-#include <math_ldbl_opt.h>
-#undef weak_alias
-#define weak_alias(n,a)
-#include <math/s_fdiml.c>
-long_double_symbol (libm, __fdiml, fdiml);
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim-vis3.c b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim-vis3.c
index 2973b49..6176517 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim-vis3.c
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim-vis3.c
@@ -19,5 +19,7 @@
 #include <math.h>
 
 #define __fdim __fdim_vis3
+#define declare_mgen_alias(t, f)
+#define M_LIBM_NEED_COMPAT(f) 0
 
 #include <math/s_fdim.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim.c b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim.c
index 9666741..2d07f31 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim.c
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdim.c
@@ -27,6 +27,7 @@ sparc_libm_ifunc(__fdim, hwcap & HWCAP_SPARC_VIS3 ? __fdim_vis3 : __fdim_generic
 weak_alias (__fdim, fdim)
 
 # define __fdim __fdim_generic
+# define declare_mgen_alias(t, f)
 #endif
 
-#include <ldbl-opt/s_fdim.c>
+#include <math/s_fdim.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf-vis3.c b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf-vis3.c
index 75997c6..3f35b0d 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf-vis3.c
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf-vis3.c
@@ -19,5 +19,6 @@
 #include <math.h>
 
 #define __fdimf __fdimf_vis3
+#define declare_mgen_alias(t, f)
 
 #include <math/s_fdimf.c>
diff --git a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf.c b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf.c
index 767520f..b9add1c 100644
--- a/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf.c
+++ b/sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/s_fdimf.c
@@ -27,6 +27,8 @@ sparc_libm_ifunc(__fdimf, hwcap & HWCAP_SPARC_VIS3 ? __fdimf_vis3 : __fdimf_gene
 weak_alias (__fdimf, fdimf)
 
 # define __fdimf __fdimf_generic
+# define declare_mgen_alias(t, f)
+
 #endif
 
 #include <math/s_fdimf.c>