diff --git a/math/Makefile b/math/Makefile
index 50ce418..f731c7d 100644
--- a/math/Makefile
+++ b/math/Makefile
@@ -53,7 +53,7 @@ gen-libm-calls = cargF conjF cimagF crealF cabsF s_cacosF		  \
 		 s_ctanF s_ctanhF s_cexpF s_clogF s_cprojF s_csqrtF	  \
 		 s_cpowF s_clog10F s_fdimF s_nextdownF s_fmaxF s_fminF	  \
 		 s_nanF s_iseqsigF s_canonicalizeF w_ilogbF w_llogbF	  \
-		 w_log1pF
+		 w_log1pF w_scalblnF
 
 libm-calls =								  \
 	e_acosF e_acoshF e_asinF e_atan2F e_atanhF e_coshF e_expF e_fmodF \
@@ -63,7 +63,7 @@ libm-calls =								  \
 	k_cosF k_sinF k_tanF s_asinhF s_atanF s_cbrtF			  \
 	s_ceilF s_cosF s_erfF s_expm1F s_fabsF				  \
 	s_floorF s_log1pF s_logbF				  \
-	s_nextafterF s_nexttowardF s_rintF s_scalblnF w_scalblnF	  \
+	s_nextafterF s_nexttowardF s_rintF s_scalblnF			  \
 	s_significandF s_sinF s_tanF s_tanhF w_acosF w_acoshF w_asinF	  \
 	w_atan2F w_atanhF w_coshF w_expF w_exp2F w_exp10F w_fmodF	  \
 	w_tgammaF w_hypotF w_j0F w_j1F w_jnF w_lgammaF w_lgammaF_r	  \
diff --git a/math/w_scalbln.c b/math/w_scalbln.c
deleted file mode 100644
index bcc3319..0000000
--- a/math/w_scalbln.c
+++ /dev/null
@@ -1,40 +0,0 @@
-/* Wrapper for __scalbln handles setting errno.
-   Copyright (C) 2014-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-double
-__w_scalbln (double x, long int n)
-{
-  if (!isfinite (x) || x == 0.0)
-    return x + x;
-
-  x = __scalbln (x, n);
-
-  if (!isfinite (x) || x == 0.0)
-    __set_errno (ERANGE);
-
-  return x;
-}
-weak_alias (__w_scalbln, scalbln)
-
-#ifdef NO_LONG_DOUBLE
-weak_alias (__w_scalbln, scalblnl)
-#endif
diff --git a/math/w_scalbln_template.c b/math/w_scalbln_template.c
new file mode 100644
index 0000000..7497c35
--- /dev/null
+++ b/math/w_scalbln_template.c
@@ -0,0 +1,41 @@
+/* Wrapper for __scalbln handles setting errno.
+   Copyright (C) 2014-2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <math.h>
+#include <math_private.h>
+
+FLOAT
+M_DECL_FUNC (__w_scalbln) (FLOAT x, long int n)
+{
+  if (!isfinite (x) || x == 0.0)
+    return x + x;
+
+  x = M_SUF (__scalbln) (x, n);
+
+  if (!isfinite (x) || x == 0.0)
+    __set_errno (ERANGE);
+
+  return x;
+}
+
+/* Define strong_alias to nothing because we don't want
+   declare_mgen_alias to create a strong alias for scalblnl.  */
+#undef strong_alias
+#define strong_alias(name, alias_name)
+declare_mgen_alias (__w_scalbln, scalbln)
diff --git a/math/w_scalblnf.c b/math/w_scalblnf.c
deleted file mode 100644
index 2a0b237..0000000
--- a/math/w_scalblnf.c
+++ /dev/null
@@ -1,36 +0,0 @@
-/* Wrapper for __scalblnf handles setting errno.
-   Copyright (C) 2014-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-float
-__w_scalblnf (float x, long int n)
-{
-  if (!isfinite (x) || x == 0.0f)
-    return x + x;
-
-  x = __scalblnf (x, n);
-
-  if (!isfinite (x) || x == 0.0f)
-    __set_errno (ERANGE);
-
-  return x;
-}
-weak_alias (__w_scalblnf, scalblnf)
diff --git a/math/w_scalblnl.c b/math/w_scalblnl.c
deleted file mode 100644
index 8ee8130..0000000
--- a/math/w_scalblnl.c
+++ /dev/null
@@ -1,36 +0,0 @@
-/* Wrapper for __scalblnl handles setting errno.
-   Copyright (C) 2014-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-long double
-__w_scalblnl (long double x, long int n)
-{
-  if (!isfinite (x) || x == 0.0L)
-    return x + x;
-
-  x = __scalblnl (x, n);
-
-  if (!isfinite (x) || x == 0.0L)
-    __set_errno (ERANGE);
-
-  return x;
-}
-weak_alias (__w_scalblnl, scalblnl)
diff --git a/sysdeps/ieee754/ldbl-128ibm/w_scalblnl.c b/sysdeps/ieee754/ldbl-128ibm/w_scalblnl.c
deleted file mode 100644
index 7e73c9a..0000000
--- a/sysdeps/ieee754/ldbl-128ibm/w_scalblnl.c
+++ /dev/null
@@ -1,23 +0,0 @@
-/* Wrapper for __scalblnl handles setting errno.
-   Copyright (C) 2014-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <math_ldbl_opt.h>
-#undef weak_alias
-#define weak_alias(name, alias)
-#include <math/w_scalblnl.c>
-long_double_symbol (libm, __w_scalblnl, scalblnl);
diff --git a/sysdeps/ieee754/ldbl-64-128/w_scalblnl.c b/sysdeps/ieee754/ldbl-64-128/w_scalblnl.c
index 05d4dfe..de21087 100644
--- a/sysdeps/ieee754/ldbl-64-128/w_scalblnl.c
+++ b/sysdeps/ieee754/ldbl-64-128/w_scalblnl.c
@@ -16,10 +16,9 @@
    License along with the GNU C Library; if not, see
    <http://www.gnu.org/licenses/>.  */
 
-#include <math_ldbl_opt.h>
-#undef weak_alias
-#define weak_alias(name, alias)
-#include <math/w_scalblnl.c>
+#define declare_mgen_alias(from, to)
+#include <math-type-macros-ldouble.h>
+#include <w_scalbln_template.c>
 #if IS_IN (libm)
 long_double_symbol (libm, __w_scalblnl, scalblnl);
 #else